//*****************************************************************************
//!
//! @file $Id: mc_interface.c 1137 2008-04-17 16:35:06Z raubree $
//!
//! Copyright (c) 2007 Atmel.
//!
//! @brief d@ł̲̪֐񋟂܂B
//!
//! @todo
//! @bug
//*****************************************************************************

//_____ ݸٰ _______________________________________________________________
#include "config.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

Bool mci_direction = CW;					//!< d@ݒ肷邽߂̎gpғҰ
Bool mci_run_stop = FALSE;					//!< d@Jn܂͒~邽߂̎gpғҰ
U8 mci_ref_speed = 0;						//!< d@xݒ肷邽߂̎gpғҰ

U8 mci_measured_speed = 0;					//!< d@x𓾂邽߂̓d@Ұ
U32 mci_measured_current = 0;				//!< d@d𓾂邽߂̓d@Ұ
U8 mc_potentiometer_value = 0;				//!< d@xݒ肷邽߂̓d@Ұ

extern Bool overcurrent;

/**
* @brief	mci_runҰœd@𓮂܂B
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_run(void)
{
  if (!(PCTL & (1<<PRUN)))				/* ߓd̏ꍇA */
  {
	PSC_Init();
  }
  overcurrent = FALSE;
  mci_run_stop = TRUE;
  mc_regulation_loop();
  mc_duty_cycle(mc_get_duty_cycle());
  mc_switch_commutation(mc_get_hall());
  mc_disable_during_inrush();			/* Aߓd֎~ */
}

/**
* @brief	mci_retry_run͑x̏ꍇɑsĎs܂B
* @pre		ʰ޳ƿĳ̏
* @post		ΰٕϐɐVl
*/
void mci_retry_run(void)
{
  mci_run_stop = TRUE;
  mc_regulation_loop();
  mc_duty_cycle(mc_get_duty_cycle());
  mc_switch_commutation(mc_get_hall());
  mc_disable_during_inrush();			/* Aߓd֎~ */
}

/**
* @brief	d@̏Ԏ擾
* @pre		ʰ޳ƿĳ̏
* @post		d@sۂm܂B
*/
Bool mci_motor_is_running(void)
{
  return mci_run_stop;
}

/**
* @brief	mci_stop͓d@~܂BđxlؾĂ܂B
* @pre		d@s(mci_run executed)
* @post		d@~
*/
void mci_stop(void)
{
  mci_run_stop=FALSE;
}

/**
* @brief	۸яɎgp
* @param
* @post		ʰ޳ƿĳ̌`Ԑݒ
* @pre		Ȃ
*/
void mc_init()
{
  mc_init_HW();
  Enable_interrupt();
  mci_stop();
  mci_forward();
  mci_set_ref_speed(0);
  mc_set_measured_speed(0);
}

/*
* @brief	xύX
* @pre		d@̏
* @post		x̐Vl
*/
void mci_set_ref_speed(U8 speed)
{
  mci_ref_speed = speed;
}

/*
* @brief	xl擾
* @pre		d@̏
* @post		xl擾
*/
U8 mci_get_ref_speed(void)
{
  return mci_ref_speed;
}

/*
* @brief	]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_forward(void)
{
  mci_direction = CW;
}

/*
* @brief	t]ύX
* @pre		d@̏
* @post		̐Vl
*/
void mci_backward(void)
{
  mci_direction = CCW;
}

/*
* @brief	l擾
* @pre		d@̏
* @post		l擾
*/
U8 mci_get_motor_direction(void)
{
  return mci_direction;
}

/**
 * @brief	xݒ(p)
 * @pre		Ȃ
 * @post	mci_measured_speed
*/
void mc_set_measured_speed(U8 measured_speed)
{
  mci_measured_speed = measured_speed;
}

/**
 * @brief	x
 * @return	x(8ޯ)lԂB
 * @pre		Ȃ
 * @post	Ȃ
*/
U8 mci_get_measured_speed(void)
{
  return mci_measured_speed;
}

/**
* @brief	d@d擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ12̌(8ޯĂ̓dl)擾
*/
U16 mci_get_measured_current(void)
{
  return mci_measured_current/64;
}

/**
* @brief	̂߂'mc_measured_current'ϐݒ
* @pre		Ȃ
* @post		currentl'mc_measured_current'ݒ
*/
void mci_store_measured_current(U16 current)
{
  mci_measured_current = ((63*mci_measured_current)+(64*current))>>6;
}

/**
* @brief	ϒRl擾
* @pre		A/Dϊv敔Jn
* @post		A/Dϊ6̌(8ޯẲϒRl)擾
*/
U8 mc_get_potentiometer_value(void)
{
  return mc_potentiometer_value;
}

/**
* @brief	ϒRl'mc_potentiometer_value'ϐݒ
* @pre		A/Dϊv敔Jn
* @post		ϒRl'mc_potentiometer_value'ݒ
*/
void mc_set_potentiometer_value(U8 potentiometer)
{
  mc_potentiometer_value = potentiometer;
}

